'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function buildDisplayName(name) {
  return t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.identifier(name), t.identifier('displayName')), t.stringLiteral(name)));
}

function applyForVarDecl(path) {
  const varDeclarator = path.findParent(function (parent) {
    return parent.isVariableDeclarator();
  });

  if (varDeclarator && varDeclarator.node.id.type === 'Identifier') {
    const targetName = varDeclarator.node.id.name;

    const parent = varDeclarator.parentPath;

    if (parent.parentPath.isExportNamedDeclaration()) {
      parent.parentPath.insertAfter(buildDisplayName(targetName));
    } else {
      parent.insertAfter(buildDisplayName(targetName));
    }
  }
}

exports.default = function () {
  return {
    name: 'styled-name',
    visitor: {
      Identifier(path) {
        if (path.node.name === 'styled') {
          if (path.parentPath.isMemberExpression()) {
            applyForVarDecl(path);
          } else if (path.parentPath.isCallExpression()) {
            applyForVarDecl(path);
          }
        }
      }
    }
  };
};